

package org.omegahat.DataStructures.Data;

public interface VariableInt {
 
  /** 
     Return the which<sup>th</sup> observation.
    */
 public Object value(long  which);

 /**
    Get a {@link Variable Variable} consisting of the specified elements.
 */
 public VariableInt values(int[] i);

 /**
    Get a {@link Variable Variable} consisting of the specified elements from a
    selector object.
 */
 public VariableInt values(SelectorInt selector);



 public void add(Object value, int which);
 public void add(double value, int which);

 /**
   Return the length or number of records in this {@link VariableInt VariableInt}.
 */
 public long numObservations();

 public int read(java.io.Reader reader)  throws java.io.IOException;

 /**
  Intended to be a {@link java.util.Property Property} table
  for storing additional attributes and information about 
  a variable, including entries such as units, nicknames, source, etc.
 */
 public java.util.Hashtable metaData();

 public String getName();
 public String setName(String val);

}
/*
Copyright (c) 1998, 1999 The Omega Project for Statistical Computing.
     All rights reserved.

     Redistribution and use in source and binary forms, with or without
     modification, are permitted provided that the following conditions are
     met:

       Redistributions of source code must retain the above copyright notice,
       this list of conditions and the following disclaimer.

       Redistributions in binary form must reproduce the above copyright
       notice, this list of conditions and the following disclaimer in the
       documentation and/or other materials provided with the distribution.

       Neither name of the Omega Project for Statistical Computing nor the 
       names of its contributors may be used to endorse or promote products 
       derived from this software without specific prior written permission.

     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS ``AS IS'' AND ANY
     EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT
     SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
     PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
     INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
     STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
     THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
*/


